<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// no direct access
defined('_JEXEC') or die( 'Restricted access' );
	
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/configuration.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/content.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/field.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/user.php');
require_once(JPATH_BASE."/components/com_adsmanager/helpers/field.php");

$uri = JFactory::getURI();
$baseurl = JURI::base();
$catid = JRequest::getInt('catid',0);
$document = JFactory::getDocument();
$app = JFactory::getApplication();
loadAdsManagerCss();

$document = JFactory::getDocument();
$document->addScript(JURI::root().'components/com_adsmanager/js/jquery.cookie.js');

$confmodel  = new AdsmanagerModelConfiguration();
$conf = $confmodel->getConfiguration();

$limitstart = JRequest::getInt("limitstart",0);
$limit = $conf->ads_per_page;

$order = $app->getUserStateFromRequest('com_adsmanager.front_content.order','order',0,'int');
$orderdir = $app->getUserStateFromRequest('com_adsmanager.front_content.orderdir','orderdir','DESC');
$orderdir = strtoupper($orderdir);
if (($orderdir != "DESC") && ($orderdir != "ASC")) {
	$orderdir = "DESC";
}

$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));

$contentmodel  = new AdsmanagerModelContent();
$filter_order = $contentmodel->getFilterOrder($order);
$filter_order_dir = $orderdir;

$filters = array();
$currentSession = JSession::getInstance('none',array());
$filters['fields'] = $currentSession->get("searchfieldssql"," 1 ");
$catid = $app->getUserStateFromRequest( 'searchfieldscatid','catid',0,'integer' );
if ($catid != 0)
	$filters['category'] = $catid;

$rootid = (int)$params->get( 'rootid', 0) ;
if ($rootid !== null) {
	$filters['rootid'] = $rootid;
}

//Taking account of the search field on the list
$listuser = JRequest::getInt( 'user',	-1 );
if (($listuser == 0)&&($user->id != 0))
    $listuser = $user->id;

$usermodel = new AdsmanagerModelUser();
if ($listuser != -1) {			
    $filters['user'] = $listuser;
    $user = $usermodel->getUser($listuser);
    if(!isset($category)) {
        $category = new stdClass();
    }
    if ($conf->display_fullname) {
        $category->name = JText::_('ADSMANAGER_LIST_USER_TEXT')." ".$user->name;
    } else {
        $category->name = JText::_('ADSMANAGER_LIST_USER_TEXT')." ".$user->username;
    }
    $modeuser = 1;		
}
$session = JFactory::getSession();
$list_type = $session->get('list_type','','adsmanager');
$list_value = $session->get('list_value','','adsmanager');

if ($listuser != -1) {	
    if (($list_type == 'user')&&($list_value == $listuser)) {
        $tsearch = JRequest::getVar( 'tsearch',	$session->get('tsearch','','adsmanager'));
        $session->set('tsearch',$tsearch,'adsmanager');
    } else {
        $session->set('list_type','user','adsmanager');
        $session->set('list_value',$listuser,'adsmanager');
        $session->set('tsearch','','adsmanager');
        $tsearch = '';
    }
} else {
    if (($list_type == 'category')&&($list_value == $catid)) {
        $tsearch = JRequest::getVar( 'tsearch',	$session->get('tsearch','','adsmanager'));
        $session->set('tsearch',$tsearch,'adsmanager');
    } else {
        $session->set('list_type','category','adsmanager');
        $session->set('list_value',$catid,'adsmanager');
        $session->set('tsearch','','adsmanager');
        $tsearch = '';
    }
}

if ($tsearch != "")
{
    $filters['search'] = $tsearch;
}

if(isset($conf->map_display_all_ads) && $conf->map_display_all_ads == 1) {
    $filters = array();
    $limitstart = null;
    $limit = null;
    $filter_order = null;
    $filter_order_dir = null;
}

$total = $contentmodel->getNbContents($filters);

$db = JFactory::getDbo();

$query = "SELECT * FROM #__adsmanager_fields WHERE type = 'gmap'";
$db->setQuery($query);
$result = $db->loadObject();

if($result != null){

	/*if (isset($filters['fields']) && ($filters['fields'] != ""))
    	$filters['fields'] .= " AND (a.ad_gmap_lat != '' ";*/

    $contents = $contentmodel->getContents($filters,$limitstart, $limit,$filter_order,$filter_order_dir);
    
} else {
    $contents = array();
}

$fieldmodel  = new AdsmanagerModelField();
$field_values = $fieldmodel->getFieldValues();
$field = new JHTMLAdsmanagerField($conf,$field_values,"4",$fieldmodel->getPlugins());

//Params
if(isset($conf->map_field)) {
    $fieldName = $conf->map_field;
} else {
    $fieldName = "ad_openmap";
}
if(isset($conf->map_field_price)) {
    $fieldPriceName = $conf->map_field_price;
} else {
    $fieldPriceName = "ad_price";
}
if(isset($conf->map_display_image)) {
    $mapDisplayImage = $conf->map_display_image;
} else {
    $mapDisplayImage = "1";
}
if(isset($conf->map_display_title)) {
    $mapDisplayTitle = $conf->map_display_title;
} else {
    $mapDisplayTitle = "1";
}
if(isset($conf->map_enable_link_title)) {
    $mapDisplayLinkTitle = $conf->map_enable_link_title;
} else {
    $mapDisplayLinkTitle = "1";
}
if(isset($conf->map_display_description)) {
    $mapDisplayDescription = $conf->map_display_description;
} else {
    $mapDisplayDescription = "1";
}
if(isset($conf->map_display_price)) {
    $mapDisplayPrice = $conf->map_display_price;
} else {
    $mapDisplayPrice = "1";
}
if(isset($conf->map_link_ads)) {
    $mapLinkAds = $conf->map_link_ads;
} else {
    $mapLinkAds = "1";
}
if(isset($conf->map_default_lat)) {
    $mapDefaultLat = $conf->map_default_lat;
} else {
    $mapDefaultLat = "48.85719913498834";
}
if(isset($conf->map_default_lng)) {
    $mapDefaultLng = $conf->map_default_lng;
} else {
    $mapDefaultLng = "2.33935546875";
}
if(isset($conf->map_default_zoom)) {
    $mapDefaultZoom = $conf->map_default_zoom;
} else {
    $mapDefaultZoom = "6";
}
if(isset($conf->map_hide)) {
    $mapHide = $conf->map_hide;
} else {
    $mapHide = "1";
}
if(isset($conf->map_height)) {
    $mapHeight = $conf->map_height;
} else {
    $mapHeight = "400";
}

$fieldsArray = array($fieldPriceName);
/*$fieldsArray[] = $params->get( 'field1', "") ;
$fieldsArray[] = $params->get( 'field2', "") ;
$fieldsArray[] = $params->get( 'field3', "") ;
$fieldsArray[] = $params->get( 'field4', "") ;
$fieldsArray[] = $params->get( 'field5', "") ;*/
$listfields="";
foreach($fieldsArray as $field)
{
	if (($listfields == "")&&($field != ""))
		$listfields .= "'$field'";
	if ($field != "")
		$listfields .= ",'$field'";
}

$field_values = array();
$adfields = array();
if ($listfields != "")
{
	$adfields = $fieldmodel->getFieldsByName($listfields);
	$field_values = $fieldmodel->getFieldValues();

	foreach($adfields as $field)
	{
		if ($field->cbfieldvalues != "-1")
		{
			/*get CB value fields */
			$cbfieldvalues = $fieldmodel->getCBFieldValues($field->cbfieldvalues);
			$field_values[$field->fieldid] = $cbfieldvalues;
		}
	}
}

if(isset($adfields[$fieldPriceName])) {
	$fieldPrice = $adfields[$fieldPriceName];
}

if ($rootid!=0) {
	$urlparamroot = "&rootid=$rootid";
} else {
	$urlparamroot = "";
}

$markers = array();
$latlon = array();
foreach($contents as $content) {
    $link = TRoute::_("index.php?option=com_adsmanager&view=details$urlparamroot&id=".$content->id."&catid=".$content->catid);		
    $title = $content->ad_headline;
    $price = $content->$fieldPriceName;
    if ($price != "") {	
    	if(isset($fieldPrice)) {
	        if($fieldPrice->options == null || $fieldPrice->options->currency_symbol == '')
	            $price = sprintf(JText::_('ADSMANAGER_CURRENCY'),number_format(floatval($price), 2, '.', ' '));
	        else
	            $price = JHTMLAdsmanagerField::formatPrice($price, $fieldPrice->options);
    	} else {
    		$price = '';
    	}
        //for Right to Left language
        $price = str_replace(" ","&nbsp;",$price);
    }
    $description = JString::substr($content->ad_text, 0, 140)."[...]";
    if ((count($content->images) > 0)&&(@$content->images[0]->thumbnail)) {
        $image = JURI_IMAGES_FOLDER."/".$content->images[0]->thumbnail;
    } else {
        $image = ADSMANAGER_NOPIC_IMG;
	}
	
	$lat = $fieldName."_lat";
	$lng = $fieldName."_lng";
    
    if($content->$lat == 0)
		continue;
    if($content->published == 0)
		continue;
    
    $markers[$content->$lat.'-'.$content->$lng][$content->id] = array('image' => $image,
                       'description'=>$description,
                       'lat'=>$content->$lat,
                       'lon'=>$content->$lng,
                       'title'=>$title,
                       'link'=>$link,
                       'price'=>$price
                       );
    
}

require(JModuleHelper::getLayoutPath('mod_adsmanager_adsopenmap',$params->get( 'layout','default')));

$content="";
$path = JPATH_ADMINISTRATOR.'/../libraries/joomla/database/table';
JTable::addIncludePath($path);

?>